VERSION 5.00
Begin VB.Form frmInstances 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   1950
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3585
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1950
   ScaleWidth      =   3585
   StartUpPosition =   1  'CenterOwner
   Begin VB.OptionButton optDisplay 
      Caption         =   "Hide"
      Height          =   255
      Index           =   1
      Left            =   1245
      TabIndex        =   4
      Top             =   0
      Value           =   -1  'True
      Width           =   1080
   End
   Begin VB.OptionButton optDisplay 
      Caption         =   "Show"
      Height          =   255
      Index           =   0
      Left            =   75
      TabIndex        =   3
      Top             =   0
      Width           =   1215
   End
   Begin VB.CommandButton cmdSelectAll 
      Caption         =   "Select All"
      Height          =   300
      Left            =   45
      TabIndex        =   1
      Top             =   1620
      Width           =   3510
   End
   Begin VB.ListBox lstInstances 
      Height          =   1320
      Left            =   45
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   270
      Width           =   3510
   End
   Begin VB.Label lblInstance 
      Alignment       =   1  'Right Justify
      Caption         =   "Instance(s)"
      Height          =   255
      Left            =   2340
      TabIndex        =   2
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "frmInstances"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Private mobjApplication         As clsApplication
Private mldDisplay              As LimitedDisplay
Private mblnPromptRelease       As Boolean

Private Sub cmdSelectAll_Click()
    Dim lngPtr          As Long
    LockWindowUpdate lstInstances.hWnd
    For lngPtr = 0 To lstInstances.ListCount - 1
        lstInstances.Selected(lngPtr) = True
    Next
    LockWindowUpdate 0&
End Sub

Public Sub ShowInstances(ByRef objOwnerForm As Form, ByRef objApplication As clsApplication, Optional ByVal blnPromptRelease As Boolean = True, Optional ByVal blnShow As Boolean)
    Dim objInstance     As clsInstance
    Hide
    MousePointer = vbHourglass
    Caption = Replace(objApplication.DisplayText, vbTab, " -- ")
    mblnPromptRelease = blnPromptRelease
    lstInstances.Clear
    Set mobjApplication = objApplication
    For Each objInstance In mobjApplication
        lstInstances.AddItem objInstance.hWnd
    Next
    If blnShow Then
        optDisplay(0).Value = vbChecked
        optDisplay_Click 0
    Else
        optDisplay(1).Value = vbChecked
        optDisplay_Click 1
    End If
    MousePointer = vbDefault
    Show vbModal, objOwnerForm
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error Resume Next
    Dim objInstance     As clsInstance
    Dim lngPtr          As Long
    If mblnPromptRelease Then
        If MsgBox("Release Instance(s)?", vbYesNo, "System Tray Organizer") = vbNo Then
            Cancel = True
        End If
    End If
    For lngPtr = 0 To lstInstances.ListCount - 1
        Set objInstance = mobjApplication(lstInstances.List(lngPtr))
        If lstInstances.Selected(lngPtr) Then
            objInstance.Display = mldDisplay
            If mblnPromptRelease And Not Cancel Then
                objInstance.Mark = True
            Else
                objInstance.Mark = False
            End If
        Else
            objInstance.Mark = False
        End If
    Next
    Set mobjApplication = Nothing
End Sub

Private Sub optDisplay_Click(Index As Integer)
    Select Case Index
        Case 0:     mldDisplay = ldNormalActive
        Case 1:     mldDisplay = ldHide
    End Select
End Sub
