VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IWindowMaster"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum WindowMessage
    wmWindowCreated = &H1
    wmWindowDestroyed = &H2
End Enum

Public Event Window(ByVal lngHwnd As Long, ByVal Message As WindowMessage)

Friend Sub WindowReceived(ByVal lngHwnd As Long, ByVal Message As WindowMessage)
    RaiseEvent Window(lngHwnd, Message)
End Sub

Private Sub Class_Initialize()
    If Not SetWindowMaster Then
        Err.Raise _
            vbObjectError + 600, _
            "IWindowMaster.SetWindowMaster", _
            "use formatmessage here"
    End If
    Set pobjWindowMaster = Me
End Sub

Private Sub Class_Terminate()
    Set pobjWindowMaster = Nothing
    SetWindowMaster False
End Sub
